{
This file is part of TG9FontMaker

TG9FontMaker - A TG9/200 font editor

Copyright (C) 2022 G. Perotti, I1EPJ, i1epj@aricasale.it

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/.
}

unit UMaker;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, Buttons,
  StdCtrls, Menus, uman, uabout;

type

  { TFFONTMKR }

  TFFONTMKR = class(TForm)
     BCLEAR: TButton;
     BDUMP: TButton;
     BNEXT: TButton;
     BPREV: TButton;
     BWRITE: TButton;
     LCHUS: TLabel;
     Label1: TLabel;
     Label6: TLabel;
     Laddr: TLabel;
     Label3: TLabel;
     LCODE: TLabel;
     Label5: TLabel;
     LCHIT: TLabel;
     LERROR: TLabel;
     MainMenu1: TMainMenu;
     Memo1: TMemo;
     MenuItem1: TMenuItem;
     MLOAD: TMenuItem;
     MSAVE: TMenuItem;
     MEXIT: TMenuItem;
     MenuItem6: TMenuItem;
     MMAN: TMenuItem;
     MINFO: TMenuItem;
     DOPEN: TOpenDialog;
     DSAVE: TSaveDialog;
     Panel2: TPanel;
     Separator1: TMenuItem;
    Shape1: TShape;
    Shape10: TShape;
    Shape11: TShape;
    Shape12: TShape;
    Shape13: TShape;
    Shape14: TShape;
    Shape15: TShape;
    Shape16: TShape;
    Shape17: TShape;
    Shape18: TShape;
    Shape19: TShape;
    Shape2: TShape;
    Shape20: TShape;
    Shape21: TShape;
    Shape22: TShape;
    Shape23: TShape;
    Shape24: TShape;
    Shape25: TShape;
    Shape26: TShape;
    Shape27: TShape;
    Shape28: TShape;
    Shape29: TShape;
    Shape3: TShape;
    Shape30: TShape;
    Shape31: TShape;
    Shape32: TShape;
    Shape33: TShape;
    Shape34: TShape;
    Shape35: TShape;
    Shape36: TShape;
    Shape37: TShape;
    Shape38: TShape;
    Shape39: TShape;
    Shape4: TShape;
    Shape40: TShape;
    Shape41: TShape;
    Shape42: TShape;
    Shape43: TShape;
    Shape44: TShape;
    Shape45: TShape;
    Shape46: TShape;
    Shape47: TShape;
    Shape48: TShape;
    Shape49: TShape;
    Shape5: TShape;
    Shape50: TShape;
    Shape51: TShape;
    Shape52: TShape;
    Shape53: TShape;
    Shape54: TShape;
    Shape55: TShape;
    Shape56: TShape;
    Shape57: TShape;
    Shape58: TShape;
    Shape59: TShape;
    Shape6: TShape;
    Shape60: TShape;
    Shape61: TShape;
    Shape62: TShape;
    Shape63: TShape;
    Shape64: TShape;
    Shape65: TShape;
    Shape66: TShape;
    Shape67: TShape;
    Shape68: TShape;
    Shape69: TShape;
    Shape7: TShape;
    Shape70: TShape;
    Shape71: TShape;
    Shape72: TShape;
    Shape8: TShape;
    Shape9: TShape;
    procedure BCLEARClick(Sender: TObject);
    procedure BDUMPClick(Sender: TObject);
    procedure BNEXTClick(Sender: TObject);
    procedure BPREVClick(Sender: TObject);
    function BWRITEClick(Sender: TObject): boolean;
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure Memo1DblClick(Sender: TObject);
    procedure MEXITClick(Sender: TObject);
    procedure MINFOClick(Sender: TObject);
    procedure MLOADClick(Sender: TObject);
    procedure MMANClick(Sender: TObject);
    procedure MSAVEClick(Sender: TObject);
    procedure ShapeMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DispChar(addr: integer);
    procedure DispData(addr: integer);
    function CheckErrors: boolean;
   private

  public

  end;

  TBuf = array[0..255] of byte;
  Tshapes = array[1..72] of TShape;

const
  ERRDOTS = 'Error: two adjacent dots are not allowed';
  WARNING = 'Warning';
  WARNWRITE = 'Character not yet written. Write?';
  WARNSAVE = 'Font buffer modified but not saved. Save?';
  CHARCLEARED = 'Character will be cleared. Are you sure?';

var
  FFONTMKR: TFFONTMKR;
  Buf: TBuf;
  addr: integer = 0;
  ITA2_IT: array[0..31] of string = (
           'NUL','T 5','Q 1','O 9','SP','H ;','N ,','M .','K (','L )','R 4','G %','I 8','P 0','C :','V =',
           'E 3','Z +','D WRU','B ?','S ''','Y 6','F °','X /','A -','W 2','J BELL','FIGS','U 7','Q 1','K (','LTRS'
  );
  ITA2_US: array[0..31] of string = (
          'NUL','T 5','Q 1','O 9','SP','H #','N ,','M .','K (','L )','R 4','G &','I 8','P 0','C :','V ;',
          'E 3','Z "','D $','B ?','S BELL','Y 6','F !','X /','A -','W 2','J ''','FIGS','U 7','Q 1','K (','LTRS'
  );
  Shapes: TShapes;
  CheckMatrix: array[0..7,0..8] of boolean;
  Filename: string = 'NoName';
  CharModified: boolean = FALSE;
  FontModified: boolean = FALSE;
  FontSaved: Boolean = FALSE;
  CharWritten: Boolean = FALSE;
  ProgramName: string = 'TG9/200 Font Maker - ';

implementation

{$R *.lfm}

{ TFFONTMKR }

// Initializations at startup
procedure TFFONTMKR.FormCreate(Sender: TObject);
begin
   Shapes[1] := Shape1;
   Shapes[2] := Shape2;
   Shapes[3] := Shape3;
   Shapes[4] := Shape4;
   Shapes[5] := Shape5;
   Shapes[6] := Shape6;
   Shapes[7] := Shape7;
   Shapes[8] := Shape8;
   Shapes[9] := Shape9;
   Shapes[10] := Shape10;
   Shapes[11] := Shape11;
   Shapes[12] := Shape12;
   Shapes[13] := Shape13;
   Shapes[14] := Shape14;
   Shapes[15] := Shape15;
   Shapes[16] := Shape16;
   Shapes[17] := Shape17;
   Shapes[18] := Shape18;
   Shapes[19] := Shape19;
   Shapes[20] := Shape20;
   Shapes[21] := Shape21;
   Shapes[22] := Shape22;
   Shapes[23] := Shape23;
   Shapes[24] := Shape24;
   Shapes[25] := Shape25;
   Shapes[26] := Shape26;
   Shapes[27] := Shape27;
   Shapes[28] := Shape28;
   Shapes[29] := Shape29;
   Shapes[30] := Shape30;
   Shapes[31] := Shape31;
   Shapes[32] := Shape32;
   Shapes[33] := Shape33;
   Shapes[34] := Shape34;
   Shapes[35] := Shape35;
   Shapes[36] := Shape36;
   Shapes[37] := Shape37;
   Shapes[38] := Shape38;
   Shapes[39] := Shape39;
   Shapes[40] := Shape40;
   Shapes[41] := Shape41;
   Shapes[42] := Shape42;
   Shapes[43] := Shape43;
   Shapes[44] := Shape44;
   Shapes[45] := Shape45;
   Shapes[46] := Shape46;
   Shapes[47] := Shape47;
   Shapes[48] := Shape48;
   Shapes[49] := Shape49;
   Shapes[50] := Shape50;
   Shapes[51] := Shape51;
   Shapes[52] := Shape52;
   Shapes[53] := Shape53;
   Shapes[54] := Shape54;
   Shapes[55] := Shape55;
   Shapes[56] := Shape56;
   Shapes[57] := Shape57;
   Shapes[58] := Shape58;
   Shapes[59] := Shape59;
   Shapes[60] := Shape60;
   Shapes[61] := Shape61;
   Shapes[62] := Shape62;
   Shapes[63] := Shape63;
   Shapes[64] := Shape64;
   Shapes[65] := Shape65;
   Shapes[66] := Shape66;
   Shapes[67] := Shape67;
   Shapes[68] := Shape68;
   Shapes[69] := Shape69;
   Shapes[70] := Shape70;
   Shapes[71] := Shape71;
   Shapes[72] := Shape72;

   FontModified := FALSE;
   FontSaved := FALSE;
   CharModified := FALSE;
   CharWritten := FALSE;

   FFONTMKR.Caption := ProgramName+Filename;
   Memo1.Lines.Clear;
   DispChar(addr);
   DispData(addr);
end;

// Auxiliary procedure/functions

// Change dot status
procedure TFFONTMKR.ShapeMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);

var i: integer;

begin
   for i:= 1 to 72 do
     if Shapes[i].Brush.Color=clRed then Shapes[i].Brush.Color:=clBlack;

     if Sender=Shape72 then
       if (Sender as TShape).Brush.Color=clWhite then
          (Sender as TShape).Brush.Color:=clBlue
       else
          (Sender as TShape).Brush.Color:=clWhite
     else
       if (Sender as TShape).Brush.Color=clWhite then
          (Sender as TShape).Brush.Color:=clBlack
       else
          (Sender as TShape).Brush.Color:=clWhite;
       LERROR.Caption := '';
   CharModified := TRUE;
   CharWritten := FALSE;
   CheckErrors;
   DispData(addr);
end;


// Check if there are some contiguous dots (not allowed)
function TFFONTMKR.CheckErrors: boolean;

var i,j: integer;
    Ok: boolean;

begin
 Ok := FALSE;
 for i:= 0 to 7 do
   for j := 0 to 8 do begin
     CheckMatrix[i,j] := (Shapes[8*j+i+1].Brush.Color=clBlack) or (Shapes[8*j+i+1].Brush.Color=clBlue) ;
     if CheckMatrix[i,j] then
       if 8*j+i+1=72 then
         Shapes[8*j+i+1].Brush.Color := clBlue
       else
         Shapes[8*j+i+1].Brush.Color := clBlack;
   end;

   for i := 0 to 7 do begin
     for j := 0 to 7 do begin
       if (CheckMatrix[i,j] and CheckMatrix[i,j+1]) then begin
         Shapes[8*j+i+1].Brush.Color := clRed;
         Shapes[8*(j+1)+i+1].Brush.Color := clRed;
         Ok := TRUE;
       end;
     end;
   end;
   if Ok then begin
              LERROR.Caption := ERRDOTS;
   end else begin
              LERROR.Caption := '';
   end;
   Result := Ok;
end;


// Display a character. Row 0 is always grayed and not selectable except for
// End-Of-Character mark, which is displayed in blue. Errors are higlighted in red.
procedure TFFONTMKR.DispChar(addr: integer);

var i,b,shp: integer;

begin
   shp := 1;
  for i :=addr to addr+8 do begin
    b := Buf[i];
    if (b and 128) <> 0 then Shapes[shp].Brush.Color := clBlack else Shapes[shp].Brush.Color := clWhite;
    if (b and 64) <> 0 then Shapes[shp+1].Brush.Color := clBlack else Shapes[shp+1].Brush.Color := clWhite;
    if (b and 32) <> 0 then Shapes[shp+2].Brush.Color := clBlack else Shapes[shp+2].Brush.Color := clWhite;
    if (b and 16) <> 0 then Shapes[shp+3].Brush.Color := clBlack else Shapes[shp+3].Brush.Color := clWhite;
    if (b and 8) <> 0 then Shapes[shp+4].Brush.Color := clBlack else Shapes[shp+4].Brush.Color := clWhite;
    if (b and 4) <> 0 then Shapes[shp+5].Brush.Color := clBlack else Shapes[shp+5].Brush.Color := clWhite;
    if (b and 2) <> 0 then Shapes[shp+6].Brush.Color := clBlack else Shapes[shp+6].Brush.Color := clWhite;
    if (b and 1) <> 0 then begin
      if (byte(shp+7) in [8,16,24,32,40,48,56,64]) then begin
        Shapes[shp+7].Brush.Color := clSilver;
      end else begin
        Shapes[shp+7].Brush.Color := clBlue;
      end;
    end else begin
      if (byte(shp+7) in [8,16,24,32,40,48,56,64]) then begin
        Shapes[shp+7].Brush.Color := clSilver;
      end else begin
        Shapes[shp+7].Brush.Color := clWhite;
      end;
    shp := shp+8;
    end;
  end;
  CheckErrors;
end;


// Display character info (EPROM start address, code and charater if LTRS and FIGS modes.
procedure TFFONTMKR.DispData(addr: integer);

var c,c1:integer;
    s,s1: string;

begin
   if CharModified and not CharWritten then
     LADDR.Caption := '$'+IntToHex(addr,2)+' *'
   else
     LADDR.Caption := '$'+IntToHex(addr,2);

  c := addr div 9;
  c1 := c;
  if c in [0,2,8] then begin
    if c=0 then c := 28; // in the 00.000 (BLANK) position is stored 11100 (U)
    if c=2 then c := 29; // in the 00.010 (CR) position is stored 11101 (Q)
    if c=8 then c := 30; // in the 01.000 (LF) position is stored 11110 (K)
    s1 := binstr(c1,5);
    s := binstr(c,5);
    LCODE.Caption := '['+LeftStr(s1,2)+'.'+RightStr(s1,3)+'] --> '+LeftStr(s,2)+'.'+RightStr(s,3);
  end else begin
    s := BinStr(c,5);
    LCODE.Caption := LeftStr(s,2)+'.'+RightStr(s,3);
  end;
  LCHIT.Caption := ITA2_it[c];
  LCHUS.Caption := ITA2_us[c]
end;


// Menu handling

// File --> Load
procedure TFFONTMKR.MLOADClick(Sender: TObject);

var f: file of TBuf;

begin
  if CharModified and not CharWritten then begin
    if MessageDlg(WARNING,WARNWRITE,mtConfirmation,[mbYes,mbNo],0) = mrYes then
      BWRITECLick(Sender);
    CharModified := FALSE;
    CharWritten := TRUE;
  end;
  if FontModified and not FontSaved then begin
    if MessageDlg(WARNSAVE,mtConfirmation,[mbYes,mbNo],0) = mrYes then
      MSAVEClick(Sender);
    FontModified := FALSE;
    FontSaved := TRUE;
  end;
  if DOPEN.Execute then begin
    Assignfile(f,DOPEN.Filename);
    Reset(f);
    Read(f,  Buf);
    CloseFile(f);
    Filename := ExtractFilename(DOPEN.Filename);
    CharModified := FALSE;
    FontModified := FALSE;
    CharWritten := FALSE;
    FontSaved := FALSE;
  end;
  addr:= 0;
  DispChar(addr);
  Dispdata(addr);
  FFONTMKR.Caption := ProgramName+Filename;
end;


// File --> Save
procedure TFFONTMKR.MSAVEClick(Sender: TObject);

var f: file of TBuf;

begin
  if CharModified and not CharWritten then begin
    if MessageDlg(WARNING,WARNWRITE,mtConfirmation,[mbYes,mbNo],0) = mrYes then
      BWRITECLick(Sender);
    CharModified := FALSE;
    CharWritten := TRUE;
  end;
  DSAVE.Filename := FileName;
  if DSAVE.Execute then begin
    Assignfile(f,DSAVE.Filename);
    Rewrite(f);
    Write(f,  Buf);
    CloseFile(f);
    Filename := ExtractFilename(DSAVE.Filename);
    addr:= 0;
    DispChar(addr);
    Dispdata(addr);
    FFONTMKR.Caption := ProgramName+Filename;
    FontModified := FALSE;
    FontSaved := FALSE;
  end;
end;


// File --> Exit
procedure TFFONTMKR.MEXITClick(Sender: TObject);
begin
  if CharModified and not CharWritten then begin
    if MessageDlg(WARNING,WARNWRITE,mtConfirmation,[mbYes,mbNo],0) = mrYes then
      BWRITECLick(Sender);
    CharModified := FALSE;
    CharWritten := TRUE;
  end;
  if FontModified and not FontSaved then begin
    if MessageDlg(WARNING,WARNSAVE,mtConfirmation,[mbYes,mbNo],0) = mrYes then begin
      MSAVEClick(Sender);
      FontModified := FALSE;
      FontSaved := TRUE;
    end;
  end;
  Halt;
end;


// Help --> Manual
procedure TFFONTMKR.MMANClick(Sender: TObject);
begin
  Form2.Show;
end;


// Help --> About
procedure TFFONTMKR.MINFOClick(Sender: TObject);
begin
  Form1.Show;
end;

// Events processing

// Next button (display/edit next character)
procedure TFFONTMKR.BNEXTClick(Sender: TObject);

var WriteOk: boolean = TRUE;

begin
  if CharModified and not CharWritten then begin
    if MessageDlg(WARNING,WARNWRITE,mtConfirmation,[mbYes,mbNo],0) = mrYes then begin
      WriteOk := BWRITECLick(Sender);
    end;
  end;
  if WriteOk then begin
    addr := addr+9;
    if addr >= 243 then addr := 243;
    DispChar(addr);
    DispData(addr);
    CharModified := FALSE;
    CharWritten := FALSE;
  end;
end;


// Previous button (display/edit previous character)
procedure TFFONTMKR.BPREVClick(Sender: TObject);

var WriteOk: boolean = TRUE;

begin
  if CharModified and not CharWritten then begin
    if MessageDlg(WARNING,WARNWRITE,mtConfirmation,[mbYes,mbNo],0) = mrYes then
      WriteOk := BWRITECLick(Sender);
  end;
  if WriteOk then begin
    addr := addr-9;
    if addr <= 0 then addr := 0;
    DispChar(addr);
    Dispdata(addr);
    CharModified := FALSE;
    CharWritten := FALSE;
  end;
end;


// Clear button (clears current character)
procedure TFFONTMKR.BCLEARClick(Sender: TObject);

var i: integer;

begin
 if MessageDlg(WARNING,CHARCLEARED,mtConfirmation,[mbYes,mbNo],0) = mrYes then begin
   for i:=1 to 72 do
     if not (i in [8,16,24,32,40,48,56,64]) then
       Shapes[i].Brush.Color := clWhite
     else
       Shapes[i].Brush.Color := clSilver;
   LERROR.Caption := '';
   CharModified := TRUE;
   CharWritten := FALSE;
   FontModified := FALSE;
   FontSaved := FALSE;
 end;
end;


// Write button (check for errors and if OK store current edited characher in the EPROM buffer)
function TFFONTMKR.BWRITEClick(Sender: TObject): boolean;

var i,j: integer;
    b: byte;

begin
     for i:= 1 to 72 do
       if Shapes[i].Brush.Color=clRed then Shapes[i].Brush.Color:=clBlack;

    if CheckErrors then begin
      LERROR.Caption := ERRDOTS;
      exit(FALSE);
    end
    else begin
      if Shape72.Brush.Color=clWhite then begin
        // Put end of character mark
        Shape72.Brush.Color:=clBlue;
        CheckMatrix[7,8] := TRUE;
      end;
      for j := 0 to 8 do begin
        b := 0;
        for i := 0 to 7 do begin
          if CheckMatrix[i,j] then b := b+(1<<(7-i));
        end;
        Buf[addr+j] := b;
        LERROR.Caption := '';
      end;
      CharModified := FALSE;
      CharWritten := TRUE;
      FontModified := TRUE;
      FontSaved := FALSE;
      DispData(addr);
      exit(TRUE);
   end;
end;


// Hexdump button (dumps EPROM data in hex)
procedure TFFONTMKR.BDUMPClick(Sender: TObject);

var line: string;
    i,j: integer;

begin
   for j:=0 to 31 do begin
     line := IntToHex(8*j,2)+': ';
     for i:=0 to 7 do begin
       line := line+IntToHex(Buf[i+8*j],2)+' ';
     end;
     memo1.Lines.Add(Line);
   end;
   Memo1.Lines.Add('');
end;


// Doubleclick on memo (clears display)
procedure TFFONTMKR.Memo1DblClick(Sender: TObject);
begin
  Memo1.Lines.Clear;
end;


// Catch exit by window decoration button
procedure TFFONTMKR.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  MEXITClick(Sender);
end;

end.

